﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace Terramineral
{
    public class TWorld : ModWorld
    {
        /* DISCLAIMER
         Thanks for opening my mod because you were curious about looking at my code! Before you do though:
         
         * You are free to edit the code from this mod, but don't just copy and paste it into your mod and say it's your feature. If you use any code
         from my mod, you may edit it but not just use it! If you don't know how to edit it, look at my tutorial on the forums!
         
         * You are also free to learn from my code! You can use this mod as a base for a mod, by editing my code and then re-building the mod. However,
         please don't release the rebuilt mod as your own. It's only for learning!
         
         Thanks! 
         */

        public static int x = 0;
        public static int hX = 0;
        public static int y = 0;
        public static Vector2 Chestpos;
        public static int dX;
        public static int dY;
        public static int debug = 0;
        public static int xxx;
        public static int yyy;
        static ushort block = 38;
        //Maze Stuff
        public static int x2;
        public static int y2;
        private static int right;
        private static int top;
        private static int left;
        private static int bottom;
        private static int chestCount = 0;
        private static Vector2 mazePos;
        private static List<Vector2> Passages = new List<Vector2>() { };
        private static List<Vector2> UntouchableWalls = new List<Vector2>() { };
        private static List<Vector2> AdjacentCells = new List<Vector2>() { };
        private static List<int> NoNoX = new List<int>() { };
        private static List<int> NoNoY = new List<int>() { };
        private static string mazeColour = "Purple";
        //Maze Stuff. Oh boy.  

        private static void MakeUntouchableWalls(int x, int y)
        {
            for (int p = 3; p <= 164; p += 6)
            {
                for (int q = 3; q <= 164; q += 6)
                {
                    UntouchableWalls.Add(new Vector2(x + p, y - q));
                }
            }
        }
        private static void MakePassage(Vector2 cell, string direction)
        {
            if (direction == "S")
            {
                for (int num = 0; num < 3; num++)
                {
                    for (int num2 = 0; num2 < 3; num2++)
                    {
                        WorldGen.KillTile((int)cell.X + num, (int)cell.Y + 3 - num2);
                        Main.tile[(int)cell.X + num, (int)cell.Y + 3 - num2].active(false);
                        WorldGen.KillTile((int)cell.X + num, (int)cell.Y + 6 - num2);
                        Main.tile[(int)cell.X + num, (int)cell.Y + 6 - num2].active(false);
                    }
                }
                if (!Passages.Contains(new Vector2(cell.X, cell.Y + 3)) && !Passages.Contains(new Vector2(cell.X, cell.Y + 6)) && !UntouchableWalls.Contains(new Vector2(cell.X, cell.Y + 3)))
                {
                    Passages.Add(new Vector2(cell.X, cell.Y + 3));
                    Passages.Add(new Vector2(cell.X, cell.Y + 6));
                }
            }
            else if (direction == "N")
            {
                for (int num = 0; num < 3; num++)
                {
                    for (int num2 = 0; num2 < 3; num2++)
                    {
                        WorldGen.KillTile((int)cell.X + num, (int)cell.Y - 3 - num2);
                        Main.tile[(int)cell.X + num, (int)cell.Y - 3 - num2].active(false);
                        WorldGen.KillTile((int)cell.X + num, (int)cell.Y - 6 - num2);
                        Main.tile[(int)cell.X + num, (int)cell.Y - 6 - num2].active(false);
                    }
                }
                if (!Passages.Contains(new Vector2(cell.X, cell.Y - 3)) && !Passages.Contains(new Vector2(cell.X, cell.Y - 6)) && !UntouchableWalls.Contains(new Vector2(cell.X, cell.Y - 3)))
                {
                    Passages.Add(new Vector2(cell.X, cell.Y - 3));
                    Passages.Add(new Vector2(cell.X, cell.Y - 6));
                }
            }
            else if (direction == "E")
            {
                for (int num = 0; num < 3; num++)
                {
                    for (int num2 = 0; num2 < 3; num2++)
                    {
                        WorldGen.KillTile((int)cell.X + 3 + num, (int)cell.Y - num2);
                        Main.tile[(int)cell.X + 3 + num, (int)cell.Y - num2].active(false);
                        WorldGen.KillTile((int)cell.X + 6 + num, (int)cell.Y - num2);
                        Main.tile[(int)cell.X + 6 + num, (int)cell.Y - num2].active(false);
                    }
                }
                if (!Passages.Contains(new Vector2(cell.X + 3, cell.Y)) && !Passages.Contains(new Vector2(cell.X + 6, cell.Y)) && !UntouchableWalls.Contains(new Vector2(cell.X + 3, cell.Y)))
                {
                    Passages.Add(new Vector2(cell.X + 3, cell.Y));
                    Passages.Add(new Vector2(cell.X + 6, cell.Y));
                }
            }
            else if (direction == "W")
            {
                for (int num = 0; num < 3; num++)
                {
                    for (int num2 = 0; num2 < 3; num2++)
                    {
                        WorldGen.KillTile((int)cell.X - 3 + num, (int)cell.Y - num2);
                        Main.tile[(int)cell.X - 3 + num, (int)cell.Y - num2].active(false);
                        WorldGen.KillTile((int)cell.X - 6 + num, (int)cell.Y - num2);
                        Main.tile[(int)cell.X - 6 + num, (int)cell.Y - num2].active(false);
                    }
                }
                if (!Passages.Contains(new Vector2(cell.X - 3, cell.Y)) && !Passages.Contains(new Vector2(cell.X - 6, cell.Y)) && UntouchableWalls.Contains(new Vector2(cell.X - 3, cell.Y)))
                {
                    Passages.Add(new Vector2(cell.X - 3, cell.Y));
                    Passages.Add(new Vector2(cell.X - 6, cell.Y));
                }
            }
        }

        private static void Make3x3Block(Vector2 pos)
        {
            for (int num = 0; num < 3; num++)
            {
                for (int num2 = 0; num2 < 3; num2++)
                {
                    WorldGen.KillTile((int)pos.X + num, (int)pos.Y - num2);
                    Main.tile[(int)pos.X + num, (int)pos.Y - num2].active(false);
                    Main.tile[(int)pos.X + num, (int)pos.Y - num2].liquid = 0;
                    WorldGen.PlaceTile((int)pos.X + num, (int)pos.Y - num2, TileDef.byName["T:MazeBrick" + mazeColour]);
                }
            }
        }

        private static void CheckAdjacents(int x, int y)
        {
            AdjacentCells.Clear();
            if (Main.tile[x + 3, y].active() && x + 3 < right && !Passages.Contains(new Vector2(x + 6, y)) && !UntouchableWalls.Contains(new Vector2(x + 3, y)))
            {
                AdjacentCells.Add(new Vector2(x + 3, y));
            }
            if (Main.tile[x - 3, y].active() && x - 3 >= left && !Passages.Contains(new Vector2(x - 6, y)) && !UntouchableWalls.Contains(new Vector2(x - 3, y)))
            {
                AdjacentCells.Add(new Vector2(x - 3, y));
            }
            if (Main.tile[x, y - 3].active() && y - 3 > top && !Passages.Contains(new Vector2(x, y - 6)) && !UntouchableWalls.Contains(new Vector2(x, y - 3)))
            {
                AdjacentCells.Add(new Vector2(x, y - 3));
            }
            if (Main.tile[x, y + 3].active() && y + 3 <= bottom && !Passages.Contains(new Vector2(x, y + 6)) && !UntouchableWalls.Contains(new Vector2(x, y + 3)))
            {
                AdjacentCells.Add(new Vector2(x, y + 3));
            }
        }

        private static void CheckIslands()
        {
            foreach (Vector2 untouch in UntouchableWalls)
            {
                if (!Main.tile[(int)untouch.X + 3, (int)untouch.Y].active() && !Main.tile[(int)untouch.X - 3, (int)untouch.Y].active() && !Main.tile[(int)untouch.X, (int)untouch.Y - 3].active() && !Main.tile[(int)untouch.X, (int)untouch.Y + 3].active())
                {
                    int randomSide = Main.rand.Next(7);
                    switch(randomSide)
                    {
                        case 0:
                            Make3x3Block(new Vector2(untouch.X + 3, untouch.Y));
                            break;
                        case 1: case 4: case 5: case 6:
                            Make3x3Block(new Vector2(untouch.X - 3, untouch.Y));
                            break;
                        case 2:
                            Make3x3Block(new Vector2(untouch.X, untouch.Y - 3));
                            break;
                        case 3:
                            Make3x3Block(new Vector2(untouch.X, untouch.Y + 3));
                            break;
                        default:
                            Make3x3Block(new Vector2(untouch.X, untouch.Y));
                            break;
                    }
                }
            }
        }

        private static void GenerateMaze (int x, int y)
        {
            right = x + 165;
            top = y - 165;
            bottom = y;
            left = x;
            for (int num = 6; num < 165; num += 6)
            {
                NoNoX.Add(x - 3 + num);
            }
            for (int num = 6; num < 165; num += 6)
            {
                NoNoY.Add(y + 3 - num);
            }
            for (int num = -3; num < 165; num+= 3 )
            {
                Make3x3Block(new Vector2(x + num, y + 3));
                Make3x3Block(new Vector2(x + num, y - 165));
            }
            for (int num = 3; num > -168; num -= 3)
            {
                Make3x3Block(new Vector2(x - 3, y + num));
                Make3x3Block(new Vector2(x + 165, y + num));
            }
            for (int num2 = 0; num2 < 165; num2++ )
            {
                for (int num3 = 0; num3 < 165; num3++)
                {
                    WorldGen.KillTile(x + num2, y - num3);
                    Main.tile[x + num2, y - num3].active(false);
                    Main.tile[x + num2, y - num3].liquid = 0;
                    WorldGen.PlaceTile(x + num2, y - num3, TileDef.byName["T:MazeBrick" + mazeColour]);
                    WorldGen.KillWall(x + num2, y - num3);
                    WorldGen.PlaceWall(x + num2, y - num3, TileDef.wallByName["T:MazeWall" + mazeColour]);
                }
            }
            MakeUntouchableWalls(x, y);
            Passages.Add(new Vector2(x, y));
            for (int num = 0; num < 3; num++)
            {
                for (int num2 = 0; num2 < 3; num2++)
                {
                    WorldGen.KillTile((int)x + num, (int)y - num2);
                    WorldGen.KillTile((int)x + num, (int)y + 3 - num2);
                    WorldGen.KillTile((int)x + 165 + num, (int)y - 165 - num2);
                }
            }
            while (Passages.Count < 1567)
            {
            Start:
                int random = Main.rand.Next(0, Passages.Count);
                if (NoNoX.Contains((int)Passages[random].X) || NoNoY.Contains((int)Passages[random].Y))
                {
                    goto Start;
                }
                else
                {
                    CheckAdjacents((int)Passages[random].X, (int)Passages[random].Y);
                    if (AdjacentCells.Count == 0)
                    {
                       goto Start;
                    }
                    else
                    {
                        int random2 = Main.rand.Next(0, AdjacentCells.Count);
                        Vector2 cell = AdjacentCells[random2];
                        if (cell.X > Passages[random].X)
                        {
                            MakePassage(Passages[random], "E");
                        }
                        else if (cell.X < Passages[random].X)
                        {
                            MakePassage(Passages[random], "W");
                        }
                        else if (cell.Y < Passages[random].Y)
                        {
                            MakePassage(Passages[random], "N");
                        }
                        else if (cell.Y > Passages[random].Y)
                        {
                            MakePassage(Passages[random], "S");
                        }
                    }
                }
            }
            CheckIslands();
            foreach (Vector2 passage in Passages)
            {
                int randChance = Main.rand.Next(102);
                if (randChance < 5 && !Main.tile[(int)passage.X, (int)passage.Y+3].active())
                {
                    WorldGen.PlaceTile((int)passage.X, (int)passage.Y, 19);
                    WorldGen.PlaceTile((int)passage.X + 1, (int)passage.Y, 19);
                    WorldGen.PlaceTile((int)passage.X + 2, (int)passage.Y, 19);
                    WorldGen.PlaceTile((int)passage.X, (int)passage.Y - 1, 50, false, false, -1, Main.rand.Next(0, 6));
                    WorldGen.PlaceTile((int)passage.X + 1, (int)passage.Y - 1, 50, false, false, -1, Main.rand.Next(0, 6));
                    WorldGen.PlaceTile((int)passage.X + 2, (int)passage.Y - 1, 50, false, false, -1, Main.rand.Next(0, 6));
                }
                else if (randChance == 6 || randChance == 7 || randChance == 8)
                {
                    for (int x4 = 0; x4 < 3; x4++)
                    {
                        for (int y4 = 0; y4 < 3; y4++)
                        {
                            if (Main.rand.Next(0, 5) == 2)
                            {
                                WorldGen.PlaceTile((int)passage.X + x4, (int)passage.Y - y4, 51); //16 to 18
                            }
                        }
                    }
                }
                else if (randChance==9)
                {
                    WorldGen.PlaceTile((int)passage.X + 1, (int)passage.Y - 1, 240, false, false, -1, Main.rand.Next(16, 18)); //random skeleton
                }
            }
            while (chestCount < 5)
            {
                NewChest:
                    int Seed = (int)DateTime.Now.Ticks;
                    Random random = new Random(Seed);
                    int chestx = Main.rand.Next(x, x + 166);
                    int chesty = Main.rand.Next(y - 166, y);
                    if (!Main.tile[chestx, chesty].active() && !Main.tile[chestx + 1, chesty].active())
                    {
                        int theChest = WorldGen.PlaceChest(chestx, chesty, 21, false, 39);
                        try
                        {
                            int cont = chestCount;
                            if (cont == 0) // maze statue chest
                            {
                                Main.chest[theChest].item[0] = ItemDef.byName["T:MazeStatue"];
                                Main.chest[theChest].item[1] = ItemDef.byType[random.Next(288, 301)];
                                Main.chest[theChest].item[1].stack = random.Next(1, 3);
                                chestCount++;
                            }
                            else if (cont==1) // Accessory / money single stack main item
                            {
                                List<int> randloot1 = new List<int>() { 167, 50, 49, 111, 73 };
                                Main.chest[theChest].item[0] = ItemDef.byType[randloot1[random.Next(0, randloot1.Count)]];
                                Main.chest[theChest].item[1] = ItemDef.byType[random.Next(2344, 2357)];
                                Main.chest[theChest].item[1].stack = random.Next(1, 4);
                                if (random.Next(4)==1) Main.chest[theChest].item[2] = ItemDef.byType[55];
                                chestCount++;
                            }
                            else if (cont==2) // Maze stone chest :D
                            {
                                Main.chest[theChest].item[0] = ItemDef.byName["T:MazeStone"];
                                Main.chest[theChest].item[1] = ItemDef.byType[97];
                                Main.chest[theChest].item[1].stack = random.Next(56, 176);
                                Main.chest[theChest].item[2] = ItemDef.byType[546];
                                Main.chest[theChest].item[2].stack = random.Next(23, 101);
                                Main.chest[theChest].item[3] = ItemDef.byType[278];
                                Main.chest[theChest].item[3].stack = random.Next(98, 397);
                                chestCount++;
                            }
                            else if (cont==3) // BOMB CHEST
                            {
                                Main.chest[theChest].item[0] = ItemDef.byType[166];
                                Main.chest[theChest].item[0].stack = random.Next(2, 15);
                                Main.chest[theChest].item[1] = ItemDef.byType[random.Next(970, 974)];
                                Main.chest[theChest].item[1].stack = random.Next(4, 23);
                                Main.chest[theChest].item[2] = ItemDef.byType[random.Next(771, 773)];
                                Main.chest[theChest].item[2].stack = random.Next(2, 9);
                                try
                                {
                                    Main.chest[theChest].item[3] = ItemDef.byName["GP:Nursenade"];
                                    Main.chest[theChest].item[3].stack = random.Next(1, 4);
                                    Main.chest[theChest].item[4] = ItemDef.byName["GP:DemoBomb"];
                                    Main.chest[theChest].item[4].stack = random.Next(1, 3);
                                }
                                catch { }
                                chestCount++;
                            }
                            else if (cont==4) //Statue and vanity
                            {
                                Main.chest[theChest].item[0] = ItemDef.byType[random.Next(438, 479)];
                                int vanity = Main.rand.Next(3);
                                if (vanity == 0)
                                {
                                    Main.chest[theChest].item[1] = ItemDef.byType[503];
                                    Main.chest[theChest].item[2] = ItemDef.byType[504];
                                    Main.chest[theChest].item[3] = ItemDef.byType[505];
                                }
                                else if (vanity == 1)
                                {
                                    Main.chest[theChest].item[1] = ItemDef.byType[588];
                                    Main.chest[theChest].item[2] = ItemDef.byType[589];
                                    Main.chest[theChest].item[3] = ItemDef.byType[590];
                                }
                                else
                                {
                                    Main.chest[theChest].item[1] = ItemDef.byType[873];
                                    Main.chest[theChest].item[2] = ItemDef.byType[874];
                                    Main.chest[theChest].item[3] = ItemDef.byType[875];
                                }
                                chestCount++;
                            }
                        }
                        catch 
                        {
                            goto NewChest;
                        }
                    }
                    else
                    {
                        goto NewChest;
                    }
            }
        }

        //Stuff such as functions and overrides
        public static void fillChest(int chest1)
        {
            List<int> largeStack = new List<int> { 5, 23, 8, 40, 41, 71, 149, 150, 225, 42, 279, 282, 286 }; // up to 67
            List<int> mediumStack = new List<int> { 72, 166, 313, 314, 183 }; // up to 36
            List<int> smallStack = new List<int> { 5, 23, 184, 235, 317, 357, 177, 178
                , 179, 180, 181, 182, 999, 28, 110, 188, 189, 226, 227
                , 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300
                , 301, 302, 303, 304, 305, 2322, 2323, 2324, 2325, 2326, 2327, 2328
                , 2329, 2344, 2345, 2346, 2347, 2348, 2349, 2350, 2351, 2352, 2353
                , 2354, 2355, 2356, 2359, 19, 20, 21, 22, 703, 704, 705, 706 }; // up to 5
            List<int> singleStack = new List<int> { 73, 118, 332, 205, 216, 2019, 167, 35, 108, 206, 207, 285 }; //1
            int largeAm = Main.rand.Next(15, 68);
            int medAm = Main.rand.Next(5, 37);
            int smallAm = Main.rand.Next(2, 6);
            if (Main.rand.Next(2)==0)
            {
                int index = Main.rand.Next(0, largeStack.Count);
                Main.chest[chest1].item[0] = ItemDef.byType[largeStack[index]];
                Main.chest[chest1].item[0].stack = largeAm;
                largeStack.RemoveAt(index);
                if (Main.rand.Next(2)==1)
                {
                    int index2 = Main.rand.Next(0, mediumStack.Count);
                    Main.chest[chest1].item[1] = ItemDef.byType[mediumStack[index2]];
                    Main.chest[chest1].item[1].stack = medAm;
                    mediumStack.RemoveAt(index);
                    if (Main.rand.Next(2)==0)
                    {
                        int index3 = Main.rand.Next(0, smallStack.Count);
                        Main.chest[chest1].item[2] = ItemDef.byType[smallStack[index3]];
                        Main.chest[chest1].item[2].stack = smallAm;
                        smallStack.RemoveAt(index);
                        if (Main.rand.Next(2) == 1)
                        {
                            int index4 = Main.rand.Next(0, singleStack.Count);
                            Main.chest[chest1].item[2] = ItemDef.byType[singleStack[index4]];
                            Main.chest[chest1].item[2].stack = 1;
                            singleStack.RemoveAt(index);
                        }
                    }
                }
            }
        }

        public static void Sphere(int dX, int dY, int size, bool place = false, ushort placeType = 1, bool liquid = false, byte liquidType = 0)
        {
            float num = dX;
            float num2 = dY;
            float num5 = size;
            int num6 = (int)(num - num5);
            debug++;

            while ((float)num6 <= num + num5)
            {
               int num7 = (int)(num2 - num5);
               while ((float)num7 <= num2 + num5)
               {
                    if ((double)(System.Math.Abs((float)num6 - num) + System.Math.Abs((float)num7 - num2)) < (double)num5 * (1.0 + (double)WorldGen.genRand.Next(-10, 11) * 0.005))
                    {
                        if (!place)
                        {
                            Main.tile[num6, num7].active(false);
                        }
                        else
                        {
                            Main.tile[num6, num7].active(true);
                            Main.tile[num6, num7].type = placeType;
                        }
                        if (liquid)
                        {
                            Main.tile[num6, num7].liquid = liquidType;
                        }
                    }
                    num7++;
                }
                num6++;
            }
        }

        public static void GenBuilding(int x, int y, int type = 0)
        {
            try
            {
                if (type == 0)
                {
                    int high = Main.rand.Next(28, 40);
                    int len = Main.rand.Next(9, 17);
                    int floor = (int)high / 3;
                    int floor2 = floor * 2;
                    for (int num3 = 0; num3 <= len; num3++)
                    {
                        for (int num4 = 0; num4 <= high; num4++)
                        {
                            WorldGen.KillTile(x + num3, y - num4);
                        }
                    }
                    for (int num3 = 1; num3 < len; num3++)
                    {
                        for (int num4 = 1; num4 < high; num4++)
                        {
                            WorldGen.KillWall(x + num3, y - num4);
                            WorldGen.PlaceWall(x + num3, y - num4, 5);
                        }
                    }
                    for (int num = 0; num <= high; num++)
                    {
                        WorldGen.PlaceTile(x, y - num, 38);
                        WorldGen.PlaceTile(x + len, y - num, 38);
                    }
                    for (int num2 = 0; num2 <= len; num2++)
                    {
                        WorldGen.PlaceTile(x + num2, y, 38);
                        WorldGen.PlaceTile(x + num2, y - high, 38);
                        //floors
                        WorldGen.PlaceTile(x + num2, y - floor, 38);
                        WorldGen.PlaceTile(x + num2, y - floor2, 38);
                    }
                    for (int num3 = 1; num3 <= 3; num3++) WorldGen.KillTile(x + len, y - floor2 - num3);
                    WorldGen.PlaceDoor(x + len, y - floor2 - 1, 10, 0);
                    if (Main.rand.Next(2) == 0)
                    {
                        for (int num4 = 1; num4 <= 3; num4++) WorldGen.KillTile(x, y - floor - num4);
                        WorldGen.PlaceDoor(x, y - floor - 1, 10, 0);
                    }
                    if (Main.rand.Next(5) == 0)
                    {
                        int tX = Main.rand.Next(3, len - 3);
                        WorldGen.PlaceTile(x + tX, y - floor - 1, 14);
                        if (Main.rand.Next(2) == 0)
                        {
                            WorldGen.PlaceTile(x + tX + 2, y - floor - 1, 15, false, false, -1);
                        }
                        else
                        {
                            WorldGen.PlaceTile(x + tX + 2, y - floor - 1, 15, false, false, 0);
                        }
                    }
                    else if (Main.rand.Next(5) == 1)
                    {
                        int tX = Main.rand.Next(3, len - 3);
                        WorldGen.PlaceTile(x + Main.rand.Next(3, len - 3), y - floor2 - 1, 14);
                        if (Main.rand.Next(2) == 0)
                        {
                            WorldGen.PlaceTile(x + tX + 2, y - floor2 - 1, 15, false, false, -1);
                        }
                        else
                        {
                            WorldGen.PlaceTile(x + tX + 2, y - floor2 - 1, 15, false, false, 0);
                        }
                    }
                }
                else if (type==1)
                {
                    int high = 14;
                    int len = 11;
                    int platform = 2;
                    int platform2 = 6;
                    int platform3 = 10;
                    for (int kl = 0; kl <= len; kl++)
                    {
                        for (int kh = 0; kh <= high; kh++)
                        {
                            WorldGen.KillTile(x + kl, y - kh);
                        }
                    }
                    for (int num5 = 1; num5 < len; num5++)
                    {
                        for (int num4 = 1; num4 < high; num4++)
                        {
                            WorldGen.KillWall(x + num5, y - num4);
                            WorldGen.PlaceWall(x + num5, y - num4, 5);
                        }
                    }
                    for (int num = 0; num <= len; num++)
                    {
                        WorldGen.KillTile(x + num, y);
                        WorldGen.PlaceTile(x + num, y, 38);
                        WorldGen.KillTile(x + num, y - high);
                        WorldGen.PlaceTile(x + num, y - high, 38);
                    }
                    for (int num2 = 0; num2 <= high; num2++)
                    {
                        WorldGen.KillTile(x, y - num2);
                        WorldGen.PlaceTile(x, y - num2, 38);
                        WorldGen.KillTile(x + len, y - num2);
                        WorldGen.PlaceTile(x + len, y - num2, 38);
                    }
                    for (int num3 = 1; num3 < len; num3++)
                    {
                        WorldGen.PlaceTile(x + num3, y - platform, 19);
                        WorldGen.PlaceTile(x + num3, y - platform2, 19);
                        WorldGen.PlaceTile(x + num3, y - platform3, 19);
                    }
                    for (int num6 = 1; num6 < len; num6++)
                    {
                        if (num6 % 2 != 0)
                        {
                            int chest1 = WorldGen.PlaceChest(x + num6, y - platform - 1);
                            fillChest(chest1);
                            int chest2 = WorldGen.PlaceChest(x + num6, y - platform2 - 1);
                            fillChest(chest2);
                            int chest3 = WorldGen.PlaceChest(x + num6, y - platform3 - 1);
                            fillChest(chest3);
                        }
                    }
                    try
                    {
                        for (int num10 = -1; !Main.tile[x + num10, y - high].active(); num10--)
                        {
                            WorldGen.PlaceTile(x + num10, y - high, 19);
                        }
                        for (int num10 = 1; !Main.tile[x + num10, y - high].active(); num10++)
                        {
                            WorldGen.PlaceTile(x + len + num10, y - high, 19);
                        }
                    }
                    catch
                    {
                    }
                }
                else if (type == 2)
                {
                    int high = Main.rand.Next(6, 8);
                    int len = Main.rand.Next(9, 13);
                    int offG = Main.rand.Next(21, 28);
                    int yy = y - offG;
                    for (int num = 0; num <= len; num++)
                    {
                        for (int num2 = 0; num2 <= high; num2++)
                        {
                            WorldGen.KillTile(x + num, yy - num2);
                        }
                        WorldGen.PlaceTile(x + num, yy, 38);
                        WorldGen.PlaceTile(x + num, yy - high, 38);
                    }
                    for (int num3 = 1; num3 < len; num3++)
                    {
                        for (int num4 = 1; num4 < high; num4++)
                        {
                            WorldGen.KillWall(x + num3, yy - num4);
                            WorldGen.PlaceWall(x + num3, yy - num4, 5);
                        }
                    }
                    for (int num5 = 0; num5 <= high; num5++)
                    {
                        WorldGen.PlaceTile(x, yy - num5, 38);
                        WorldGen.PlaceTile(x + len, yy - num5, 38);
                    }
                    for (int num6 = 1; !Main.tile[x, yy - high - num6].active(); num6++)
                    {
                        WorldGen.PlaceWall(x, yy - high - num6, 107);
                    }
                    for (int num6 = 1; !Main.tile[x + len, yy - high - num6].active(); num6++)
                    {
                        WorldGen.PlaceWall(x + len, yy - high - num6, 107);
                    }
                    int ch = WorldGen.PlaceChest(x + (int)(len / 2), yy - 1, 21, false, 12);
                    for (int slot = 0; slot < 5; slot++)
                    {
                        int ran = WorldGen.genRand.Next(0, 2);
                        if (ran == 0)
                        {
                            Main.chest[ch].item[slot] = ItemDef.byName["T:VialOfSlime"];
                            Main.chest[ch].item[slot].stack = WorldGen.genRand.Next(5, 11);
                        }
                        else
                        {
                            Main.chest[ch].item[slot] = ItemDef.byName["T:MysticDust"];
                            Main.chest[ch].item[slot].stack = WorldGen.genRand.Next(5, 11);
                        }
                    }
                }
            }
            catch
            {
            }
        }

        public static void AddTerraminOres()
        {
            for (int num2 = 0; num2 < (int)(Main.maxTilesX / 100); num2++)
            {
                WorldGen.OreRunner(Main.rand.Next(0, Main.maxTilesX), Main.rand.Next((int)Main.worldSurface + 300, (int)Main.hellLayer), (double)WorldGen.genRand.Next(3, 8), WorldGen.genRand.Next(3, 9), TileDef.byName["T:RhodiumOre"]);
            }
            //eosphorite
            for (int num2 = 0; num2 < (int)(Main.maxTilesX / 12); num2++)
            {
                WorldGen.OreRunner(Main.rand.Next(0, Main.maxTilesX), Main.rand.Next((int)Main.worldSurface + 300, (int)Main.hellLayer), (double)WorldGen.genRand.Next(5, 9), WorldGen.genRand.Next(5, 9), TileDef.byName["T:EosphoriteOre"]);
            }
            //erythrite
            for (int num2 = 0; num2 < (int)(Main.maxTilesX / 12); num2++)
            {
                WorldGen.OreRunner(Main.rand.Next(0, Main.maxTilesX), Main.rand.Next((int)Main.worldSurface + 300, (int)Main.hellLayer), (double)WorldGen.genRand.Next(5, 9), WorldGen.genRand.Next(5, 9), TileDef.byName["T:ErythriteOre"]);
            }
            //jouravskite
            for (int num2 = 0; num2 < (int)(Main.maxTilesX / 30); num2++)
            {
                WorldGen.OreRunner(Main.rand.Next(0, Main.maxTilesX), Main.rand.Next((int)Main.worldSurface + 300, (int)Main.hellLayer), (double)WorldGen.genRand.Next(5, 9), WorldGen.genRand.Next(5, 9), TileDef.byName["T:JouravskiteOre"]);
            }
            //geothite
            for (int num2 = 0; num2 < (int)(Main.maxTilesX / 20); num2++)
            {
                WorldGen.OreRunner(Main.rand.Next(0, Main.maxTilesX), Main.rand.Next((int)Main.worldSurface + 300, (int)Main.hellLayer), (double)WorldGen.genRand.Next(5, 9), WorldGen.genRand.Next(5, 9), TileDef.byName["T:GoethiteOre"]);
            }
            //Ore item checker
            WorldGen.PlaceTile(100, 100, TileDef.byName["T:RhodiumOre"]);
        }

        public override void WorldGenPostGen()
        {
            if ((bool)modBase.options["generateMaze"].Value)
            {
                Main.statusText = "Generating the Maze...";
                do
                {
                    if (WorldGenTask.Gen.dungeonDir != 1)
                    {
                        x2 = Main.rand.Next(Main.maxTilesX / 2, (Main.maxTilesX / 2) + 600);
                    }
                    else
                    {
                        x2 = Main.rand.Next((Main.maxTilesX/2) - 600, Main.maxTilesX / 2);
                    }
                    y2 = Main.rand.Next((int)Main.rockLayer + 150, WorldGen.lavaLine - 30);
                } while (Main.tile[x2, y2].type != 0 && Main.tile[x2, y2].type != 1 && Main.tile[x2 + 165, y2].type != 0 && Main.tile[x2 + 165, y2].type != 1 && Main.tile[x2, y2 - 165].type != 0 && Main.tile[x2, y2 - 165].type != 1 && Main.tile[x2 + 165, y2 - 165].type != 0 && Main.tile[x2 + 165, y2 - 165].type != 1);
                GenerateMaze(x2, y2);
            }
        }

        public override void WorldGenModifyTaskList(List<WorldGenTask> list)
        {
            #region mazeVariableResets
            mazeColour = (string)modBase.options["mazeColour"].Value;
            Passages.Clear();
            AdjacentCells.Clear();
            UntouchableWalls.Clear();
            NoNoX.Clear();
            NoNoY.Clear();
            chestCount = 0;
            #endregion
            if ((bool)modBase.options["generateOres"].Value)
            {
                list.Insert(19, new WorldGenTask.Action("Terramineral:Ores", delegate
                {
                    Main.statusText = "Adding Terramineral Ores...";
                    AddTerraminOres();
                }));
            }
            #region Structures // All code by TheGamingBoffin
            if ((bool)modBase.options["generateMineshafts"].Value)
            {
                list.Insert(31, new WorldGenTask.Action("Terramineral:Mineshaft", delegate
                {
                    double perc = 100 / ((Main.maxTilesX / 100) / 2);
                    double addToPerc = perc;
                    for (int amount = 0; amount < (Main.maxTilesX / 100) / 2; amount++)
                    {
                        Main.statusText = string.Concat(new object[]
                        {
                            "Generating Mineshafts: ",
                            (int)perc,
                            "%"
                        });
                        perc += addToPerc;
                        do
                        {
                            x = Main.rand.Next(400, Main.maxTilesX - 400);
                            y = Main.rand.Next((int)Main.rockLayer + 100, (int)Main.hellLayer - 100);
                        } while (WorldGen.EmptyTileCheck(x, x, y, y) && WorldGen.EmptyTileCheck(x + 40, x + 40, y, y) && WorldGen.EmptyTileCheck(x, x, y - 5, y - 5) && WorldGen.EmptyTileCheck(x + 40, x + 40, y - 5, y - 5) && Main.tile[x, y].type != 1 && Main.tile[x, y - 5].type != 1);

                        int num3 = Main.rand.Next(9, 14);
                        bool chest = false;
                        int num5 = Main.maxTilesY / 600;

                        for (int num6 = 0; num6 <= num5; num6++)
                        {
                            chest = false;
                            for (int num = 0; num <= Main.rand.Next(40, 100); num++)
                            {
                                for (int num2 = 0; num2 <= 5; num2++)
                                {
                                    WorldGen.KillTile(x + num, y - num2);
                                }
                                WorldGen.PlaceTile(x + num, y, 314);
                                WorldGen.PlaceTile(x + num, y - 5, 30);
                                if (Main.rand.Next(15) == 0 && !chest)
                                {
                                    try
                                    {
                                        for (int num7 = 0; num7 <= 1; num7++) WorldGen.KillTile(x + num + num7, y);
                                        int chest1 = WorldGen.PlaceChest(x + num, y);
                                        Chestpos = new Vector2(x + num, y);
                                        chest = true;
                                        //if (Main.rand.Next(3) == 0)
                                        //{
                                        if (WorldGen.goldBar == 19)
                                        {
                                            Main.chest[chest1].item[0].SetDefaults(-1);
                                            Main.chest[chest1].item[0].Prefix(-1, true);
                                            Main.chest[chest1].item[1].SetDefaults(13);
                                            Main.chest[chest1].item[1].stack = Main.rand.Next(18, 74);
                                            if (Main.rand.Next(5) >= 2)
                                            {
                                                Main.chest[chest1].item[2].SetDefaults(19);
                                                Main.chest[chest1].item[2].stack = Main.rand.Next(4, 16);
                                            }
                                        }
                                        else
                                        {
                                            Main.chest[chest1].item[0].SetDefaults(-43);
                                            Main.chest[chest1].item[0].Prefix(-1, true);
                                            Main.chest[chest1].item[1].SetDefaults(702);
                                            Main.chest[chest1].item[1].stack = Main.rand.Next(18, 74);
                                            if (Main.rand.Next(5) >= 2)
                                            {
                                                Main.chest[chest1].item[2].SetDefaults(706);
                                                Main.chest[chest1].item[2].stack = Main.rand.Next(4, 16);
                                            }
                                        }
                                        //}
                                    }
                                    catch
                                    {
                                        continue;
                                    }
                                }
                                if (num % num3 == 0)
                                {
                                    for (int num8 = 0; num8 < 100; num8++)
                                    {
                                        bool flag = Main.tile[x + num, y - 5 + num8].active();
                                        bool flag2 = (Main.tile[x + num, y - 5 + num8].type == 314);
                                        bool flag3 = (Main.tile[x + num, y - 5 + num8].type == 30);
                                        if (flag && !flag2 && !flag3)
                                        {
                                            WorldGen.PlaceWall(x + num, y - 5 + num8, 106);
                                            break;
                                        }
                                        else
                                        {
                                            WorldGen.PlaceWall(x + num, y - 5 + num8, 106);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }));
            }
            if ((bool)modBase.options["generateDwellerCitadel"].Value)
            {
                list.Insert(32, new WorldGenTask.Action("Terramineral:DwellerCitadel", delegate
                {
                    Main.statusText = "Building Dweller Citadel...";
                    int num12 = Main.maxTilesX / 2;
                    do
                    {
                        dX = Main.rand.Next(num12 - 500, num12 + 500);
                        dY = Main.rand.Next((int)Main.rockLayer + 100, (int)WorldGen.lavaLine - 100);
                    } while (Main.tile[dX, dY].type != 1);
                    int length = Main.rand.Next(95, 152);

                    for (int num = 0; num < length; num++)
                    {
                        int sizeRand = Main.rand.Next(14, 17);
                        Sphere(dX + num, dY, sizeRand);
                    }
                    for (int num2 = 0; num2 < length; num2++)
                    {
                        int sizeRand = Main.rand.Next(5, 8);
                        Sphere(dX + num2, dY + 26, sizeRand, true);
                    }
                    GenBuilding(dX + Main.rand.Next(5, 15), dY + Main.rand.Next(21, 24), 2);
                    GenBuilding(dX + Main.rand.Next(22, 35), dY + Main.rand.Next(21, 24), Main.rand.Next(0));
                    GenBuilding(dX + Main.rand.Next(40, 53), dY + Main.rand.Next(21, 24), Main.rand.Next(0, 2));
                    GenBuilding(dX + Main.rand.Next(61, 74), dY + Main.rand.Next(21, 24), Main.rand.Next(4));
                    GenBuilding(dX + Main.rand.Next(80, 93), dY + Main.rand.Next(21, 24), Main.rand.Next(1));
                    if (length > 96) GenBuilding(dX + Main.rand.Next(99, 112), dY + Main.rand.Next(21, 24), Main.rand.Next(0, 2));
                    if (length > 115) GenBuilding(dX + Main.rand.Next(120, 133), dY + Main.rand.Next(21, 24), Main.rand.Next(4));
                    if (length > 135) GenBuilding(dX + Main.rand.Next(137, 150), dY + Main.rand.Next(21, 24), 2);
                }));
            }
#endregion
            if ((bool)modBase.options["generateWorldHole"].Value)
            {
                list.Insert(15, new WorldGenTask.Action("Terramineral:WorldHole", delegate
                {
                    Main.statusText = "Generating World Hole...";
                    if (Main.rand.Next(2) == 0)
                    {
                        hX = Main.rand.Next(1600, Main.maxTilesX / 2 - 200);
                    }
                    else
                    {
                        hX = Main.rand.Next(Main.maxTilesX / 2 + 200, Main.maxTilesX - 1600);
                    }
                    int start = (int)Main.worldSurface - 150;
                    bool flag4 = Main.tile[hX, start].active();
                    for (int num99 = 0; num99 < 200; num99++)
                    {
                        flag4 = Main.tile[hX, start].active();
                        if (flag4)
                        {
                            break;
                        }
                        start++;
                    }
                    int bottom = Main.rand.Next((int)Main.rockLayer, (int)Main.hellLayer - 200);
                    for (int num2 = start; num2 <= bottom; num2++)
                    {
                        Sphere(hX, num2, Main.rand.Next(12, 16));
                        hX += Main.rand.Next(-3, 4);
                    }
                }));
            }
        }
    }
}
